<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>API Documentation &mdash; Heiwa  documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
      <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/jquery.js"></script>
        <script src="_static/underscore.js"></script>
        <script src="_static/doctools.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Authentication" href="heiwa.authentication.html" />
    <link rel="prev" title="Performance" href="performance.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="index.html" class="icon icon-home"> Heiwa
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="performance.html">Performance</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">API Documentation</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#subpackages">Subpackages</a><ul>
<li class="toctree-l3"><a class="reference internal" href="heiwa.authentication.html">Authentication</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.constants.html">Statuses</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.database.html">Database</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.json_ld.html">JSON-LD</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.enums.html">Enums</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.error_handlers.html">Error handlers</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.exceptions.html">Exceptions</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.limiter.html">Rate limiter</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.tasks.html">Tasks</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.types.html">Abstract types</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.validators.html">Validators</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.html">API views</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#module-heiwa">Root</a></li>
</ul>
</li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">Heiwa</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home"></a> &raquo;</li>
      <li>API Documentation</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/heiwa.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="api-documentation">
<h1>API Documentation<a class="headerlink" href="#api-documentation" title="Permalink to this headline"></a></h1>
<section id="subpackages">
<h2>Subpackages<a class="headerlink" href="#subpackages" title="Permalink to this headline"></a></h2>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="heiwa.authentication.html">Authentication</a></li>
<li class="toctree-l1"><a class="reference internal" href="heiwa.constants.html">Statuses</a></li>
<li class="toctree-l1"><a class="reference internal" href="heiwa.database.html">Database</a><ul>
<li class="toctree-l2"><a class="reference internal" href="heiwa.database.html#subpackages">Subpackages</a><ul>
<li class="toctree-l3"><a class="reference internal" href="heiwa.database.utils.html">Utilities</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.database.html#module-heiwa.database">Contents</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="heiwa.json_ld.html">JSON-LD</a></li>
<li class="toctree-l1"><a class="reference internal" href="heiwa.enums.html">Enums</a></li>
<li class="toctree-l1"><a class="reference internal" href="heiwa.error_handlers.html">Error handlers</a></li>
<li class="toctree-l1"><a class="reference internal" href="heiwa.exceptions.html">Exceptions</a></li>
<li class="toctree-l1"><a class="reference internal" href="heiwa.limiter.html">Rate limiter</a></li>
<li class="toctree-l1"><a class="reference internal" href="heiwa.tasks.html">Tasks</a></li>
<li class="toctree-l1"><a class="reference internal" href="heiwa.types.html">Abstract types</a></li>
<li class="toctree-l1"><a class="reference internal" href="heiwa.validators.html">Validators</a></li>
<li class="toctree-l1"><a class="reference internal" href="heiwa.views.html">API views</a><ul>
<li class="toctree-l2"><a class="reference internal" href="heiwa.views.category.html">Categories</a></li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.views.file.html">Files</a></li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.views.forum.html">Forums</a><ul>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.forum.html#module-heiwa.views.forum.parsed_permissions">Parsed permissions</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.forum.html#module-heiwa.views.forum.permissions_group">Group permissions</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.forum.html#module-heiwa.views.forum.permissions_user">User permissions</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.forum.html#module-heiwa.views.forum.subscription">Subscriptions</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.forum.html#module-heiwa.views.forum.utils">Utilities</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.views.group.html">Groups</a><ul>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.group.html#module-heiwa.views.group.permissions">Permissions</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.group.html#module-heiwa.views.group.utils">Utilities</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.views.guest.html">Guests</a></li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.views.message.html">Messages</a><ul>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.message.html#module-heiwa.views.message.directory">Directories</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.message.html#module-heiwa.views.message.utils">Utilities</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.views.meta.html">Meta information</a></li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.views.notification.html">Notifications</a></li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.views.oidc.html">OIDC</a></li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.views.post.html">Posts</a><ul>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.post.html#module-heiwa.views.post.vote">Votes</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.post.html#module-heiwa.views.post.utils">Utilities</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.views.statistic.html">Statistics</a></li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.views.thread.html">Threads</a><ul>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.thread.html#module-heiwa.views.thread.subscription">Subscriptions</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.thread.html#module-heiwa.views.thread.view_record">View records</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.thread.html#module-heiwa.views.thread.vote">Votes</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.views.user.html">Users</a><ul>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.user.html#module-heiwa.views.user.avatar">Avatars</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.user.html#module-heiwa.views.user.ban">Bans</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.user.html#module-heiwa.views.user.block">Blocks</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.user.html#module-heiwa.views.user.follow">Follows</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.user.html#module-heiwa.views.user.groups">Groups</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.user.html#module-heiwa.views.user.permissions">Permissions</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.user.html#module-heiwa.views.user.preferences">Preferences</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.user.html#module-heiwa.views.user.reputation">Reputation</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.views.user.html#module-heiwa.views.user.utils">Utilities</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.views.utils.html">Utilities</a></li>
</ul>
</li>
</ul>
</div>
</section>
<section id="module-heiwa">
<span id="root"></span><h2>Root<a class="headerlink" href="#module-heiwa" title="Permalink to this headline"></a></h2>
<p>Heiwa, a forum API.</p>
<dl class="py class">
<dt class="sig sig-object py" id="heiwa.ConfiguredLockFlask">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">heiwa.</span></span><span class="sig-name descname"><span class="pre">ConfiguredLockFlask</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="o"><span class="pre">*</span></span><span class="n"><span class="pre">args</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwargs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/heiwa.html#ConfiguredLockFlask"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.ConfiguredLockFlask" title="Permalink to this definition"></a></dt>
<dd><p>A Flask subclass which supports detecting and setting whether or not
everything has been set up for production use.</p>
<dl class="py method">
<dt class="sig sig-object py" id="heiwa.ConfiguredLockFlask.__init__">
<span class="sig-name descname"><span class="pre">__init__</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="o"><span class="pre">*</span></span><span class="n"><span class="pre">args</span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwargs</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="reference internal" href="_modules/heiwa.html#ConfiguredLockFlask.__init__"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.ConfiguredLockFlask.__init__" title="Permalink to this definition"></a></dt>
<dd><p>Sets whether or not this app has been configured and when the last
update to its config was. This depends on whether or not the file located
where the <code class="docutils literal notranslate"><span class="pre">CONFIGURED_LOCK_LOCATION</span></code> environment variable (or
<code class="docutils literal notranslate"><span class="pre">$current_working_directory/configured.lock</span></code>, if it’s unset) describes
exists, and its content if it does. If it doesn’t exist, the app has not
been configured. Otherwise, it has, and the last time that happened was
when the file’s content - an
<a class="reference external" href="https://wikiless.org/wiki/ISO_8601">ISO-8601</a> datetime - describes.</p>
</dd></dl>

<dl class="py property">
<dt class="sig sig-object py" id="heiwa.ConfiguredLockFlask.configured">
<em class="property"><span class="pre">property</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">configured</span></span><em class="property"><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="pre">bool</span></em><a class="headerlink" href="#heiwa.ConfiguredLockFlask.configured" title="Permalink to this definition"></a></dt>
<dd><p>Gets the value in the
<code class="xref py py-attr docutils literal notranslate"><span class="pre">_configured</span></code> instance variable.
This describes whther or not the current app has been properly set up for
production use.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The variable.</p>
</dd>
</dl>
</dd></dl>

<dl class="py property">
<dt class="sig sig-object py" id="heiwa.ConfiguredLockFlask.last_configured">
<em class="property"><span class="pre">property</span><span class="w"> </span></em><span class="sig-name descname"><span class="pre">last_configured</span></span><em class="property"><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">datetime.datetime</span><span class="p"><span class="pre">]</span></span></em><a class="headerlink" href="#heiwa.ConfiguredLockFlask.last_configured" title="Permalink to this definition"></a></dt>
<dd><p>Gets the value in the
<code class="xref py py-attr docutils literal notranslate"><span class="pre">_last_configured</span></code> instance
variable. This describes the last time the current app was re/configured.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The variable.</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.create_app">
<span class="sig-prename descclassname"><span class="pre">heiwa.</span></span><span class="sig-name descname"><span class="pre">create_app</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference internal" href="#heiwa.ConfiguredLockFlask" title="heiwa.ConfiguredLockFlask"><span class="pre">heiwa.ConfiguredLockFlask</span></a></span></span><a class="reference internal" href="_modules/heiwa.html#create_app"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.create_app" title="Permalink to this definition"></a></dt>
<dd><p>Creates a <a class="reference internal" href="#heiwa.ConfiguredLockFlask" title="heiwa.ConfiguredLockFlask"><code class="xref py py-class docutils literal notranslate"><span class="pre">ConfiguredLockFlask</span></code></a> app with settings already applied.</p>
<p>If the <code class="docutils literal notranslate"><span class="pre">FLASK_ENV</span></code> environment variable is <code class="docutils literal notranslate"><span class="pre">development</span></code>, debug mode is
enabled. If unset, it’s assumed to be <code class="docutils literal notranslate"><span class="pre">production</span></code>.</p>
<p>Loads the config from the file located where the <code class="docutils literal notranslate"><span class="pre">CONFIG_LOCATION</span></code>
environment variable describes, or <code class="docutils literal notranslate"><span class="pre">$current_working_directory/config.json</span></code>
if it’s not set.</p>
<p>Creates a SQLAlchemy engine from the <code class="docutils literal notranslate"><span class="pre">DATABASE_URI</span></code> config value and a
scoped session to use it at <code class="docutils literal notranslate"><span class="pre">app.sa_session_class</span></code>.</p>
<p>Sets the app’s <code class="docutils literal notranslate"><span class="pre">app.json_encoder</span></code> to
<a class="reference internal" href="heiwa.json_ld.html#heiwa.json_ld.JSONLDEncoder" title="heiwa.json_ld.JSONLDEncoder"><code class="xref py py-class docutils literal notranslate"><span class="pre">JSONLDEncoder</span></code></a>, a custom encoder which
supports ISO-8601 datetimes, SQLAlchemy models and such.</p>
<p>Instantiates a <a class="reference internal" href="heiwa.limiter.html#heiwa.limiter.Limiter" title="heiwa.limiter.Limiter"><code class="xref py py-class docutils literal notranslate"><span class="pre">Limiter</span></code></a> to rate limit requests.
Limits set in the <code class="docutils literal notranslate"><span class="pre">RATELIMIT_DEFAULT</span></code> and <code class="docutils literal notranslate"><span class="pre">RATELIMIT_SPECIFIC</span></code> config keys
are considered.</p>
<p>Creates a <code class="docutils literal notranslate"><span class="pre">before_request</span></code> function, which sets the global current user
identifier (<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.identifier</span></code>) to the remote IP address and creates
a basic SQLAlchemy session derived from
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.current_app.sa_session_class</span></code> at <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.sa_session</span></code>.
Also creates a <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.current_utc_time</span></code> attribute with the current
datetime in the UTC timezone.</p>
<p>Creates a <code class="docutils literal notranslate"><span class="pre">teardown_request</span></code> function, which attempts to commit
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.sa_session</span></code> and rolls it back if any exception is raised during
the process. The exception is then re-raised. Otherwise, the session is
removed and the original response is returned.</p>
<p>Registers both error handlers in <a class="reference internal" href="heiwa.error_handlers.html#module-heiwa.error_handlers" title="heiwa.error_handlers"><code class="xref py py-mod docutils literal notranslate"><span class="pre">error_handlers</span></code></a>.</p>
<p>Registers all blueprints in <a class="reference internal" href="heiwa.views.html#module-heiwa.views" title="heiwa.views"><code class="xref py py-mod docutils literal notranslate"><span class="pre">views</span></code></a>.</p>
<p>Creates a <code class="docutils literal notranslate"><span class="pre">reflect</span></code> Flask CLI command, which reflects all models to the
app’s database and creates default groups. If there are any
<a class="reference internal" href="heiwa.database.html#heiwa.database.Group" title="heiwa.database.Group"><code class="xref py py-class docutils literal notranslate"><span class="pre">Group</span></code></a>s specified in the <code class="docutils literal notranslate"><span class="pre">GROUP_DEFAULTS</span></code>
config key, they are also created, as long as they don’t exist already.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The finished app.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.get_config">
<span class="sig-prename descclassname"><span class="pre">heiwa.</span></span><span class="sig-name descname"><span class="pre">get_config</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">skip_context_check</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">bool</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">config_location_envvar</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">'CONFIG_LOCATION'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fallback_name</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">'config.json'</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Dict</span><span class="p"><span class="pre">[</span></span><span class="pre">str</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">Any</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa.html#get_config"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.get_config" title="Permalink to this definition"></a></dt>
<dd><p>Gets the current JSON config for this service.</p>
<p>If this function is run in a Flask context and <code class="docutils literal notranslate"><span class="pre">skip_context_check</span></code> is
<code class="xref py py-data docutils literal notranslate"><span class="pre">True</span></code>, <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.current_app.config</span></code> is returned. Otherwise, an
attempt is made to use the <code class="docutils literal notranslate"><span class="pre">config_location_envvar</span></code> environment variable
for the config file. If it exists, the location it points to will be used.
Otherwise, the current working directory’s <code class="docutils literal notranslate"><span class="pre">fallback_name</span></code> is used.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>config_location_envvar</strong> – The environment variable to use in order to
find the custom config file. <code class="docutils literal notranslate"><span class="pre">CONFIG_LOCATION</span></code> by default.</p></li>
<li><p><strong>fallback_name</strong> – The filename to use when the environment variable is
not set. Defaults to <code class="docutils literal notranslate"><span class="pre">config.json</span></code>.</p></li>
</ul>
</dd>
</dl>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>It’s assumed that if the environment variable is set, the location is
valid and the file exists. If it is not set, <code class="docutils literal notranslate"><span class="pre">config.json</span></code> must exist.</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The config, in a Python dictionary.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.run_scheduler">
<span class="sig-prename descclassname"><span class="pre">heiwa.</span></span><span class="sig-name descname"><span class="pre">run_scheduler</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="reference internal" href="_modules/heiwa.html#run_scheduler"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.run_scheduler" title="Permalink to this definition"></a></dt>
<dd><p>Creates a <a class="reference internal" href="heiwa.tasks.html#heiwa.tasks.SchedulerService" title="heiwa.tasks.SchedulerService"><code class="xref py py-class docutils literal notranslate"><span class="pre">SchedulerService</span></code></a> and run a
RPyC server in order for other programs to be able to interface with it. If
the <code class="docutils literal notranslate"><span class="pre">RPYC_PORT</span></code> config value is <code class="docutils literal notranslate"><span class="pre">0</span></code>, only the scheduler will run and no
external communication is possible.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Adapted from an <a class="reference external" href="https://github.com/agronholm/apscheduler/com mit/19fa2fa27a7e168fbcec883817408a21a8b7339e">example</a> by
<a class="reference external" href="https://github.com/agronholm">Alex Grönholm</a>.</p>
</div>
</dd></dl>

</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="performance.html" class="btn btn-neutral float-left" title="Performance" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="heiwa.authentication.html" class="btn btn-neutral float-right" title="Authentication" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p></p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>